#include "idx2col.h"

//#include <stdexcept>


DXFColor index2Color(int i)
{
	double max;
	double inc;
	DXFColor curCol;//={0,0,0};

	if(i<10){
		switch(i){
			case 1:	//1|0|0=4;
				curCol.R=1; curCol.G=0; curCol.B=0; //i=1;//Red
				break;
			case 2:	//1|1|0=6;
				curCol.R=1; curCol.G=1; curCol.B=0;//i=2;//Yellow
				break;
			case 3:	//0|1|0=2;
				curCol.R=0; curCol.G=1; curCol.B=0;//i=3;//Green
				break;
			case 4:	//0|1|1=3;
				curCol.R=0; curCol.G=1; curCol.B=1; //i=4;//Cyan
				break;
			case 5:	//0|0|1=1;
				curCol.R=0; curCol.G=0; curCol.B=1; //i=5;//Blue
				break;
			case 6:	//1|0|1=5;
				curCol.R=1; curCol.G=0; curCol.B=1; //i=6;//Magenta
				break;
			case 7:	//1|1|1=7;
				curCol.R=1; curCol.G=1; curCol.B=1; //i=7;//White
				break;
			default:
			//case 0://0|0|0=0; i=0; Be defined by Layer;;;;;;;;;;;
			//case 8://case 9:
				curCol.R=0; curCol.G=0; curCol.B=0; //i=8;//Undefined Black //i=9;//Undefined Black
				break;
		}
	}//i<10 END	/////////////////////////////////////////////////////////////////////////////////

	else if(i<250){
		int up2digts = (int)i/10; // Extract upper 2 digits of 10 TO 249
		inc=.25;
		switch(up2digts)
		{
			//10red TO 40orange
			case 1:	case 2:	case 3:	case 4:
				curCol.R=1; curCol.G=(up2digts-1)*inc; curCol.B=0;
				break;
			//50yellow TO 80yellow green
			case 5:	case 6:	case 7:	case 8:
				curCol.R=1-(up2digts-5)*inc; curCol.G=1; curCol.B=0;
				break;
			//90{0,1,0}green//100{0,1,.25}green turqoise//110{0,1,.5}turqouise//120{0,1,.75}blueTurqoise
			case 9:	case 10: case 11: case 12:
				curCol.R=0; curCol.G=1; curCol.B=(up2digts-9)*inc;
				break;
			//{0,1,1};130cyan//{0,.75,1};140//{0,.5,1};150//{0,.25,1};160	
			case 13: case 14: case 15: case 16:
				curCol.R=0; curCol.G=1-(up2digts-13)*inc; curCol.B=1;
				break;
			//{0,0,1};170blue//{.25,0,1};180blue violet//{.5,0,1};190violet//{.75,0,1};200violet magenta
			case 17: case 18: case 19: case 20:
				curCol.R=(up2digts-17)*inc; curCol.G=0; curCol.B=1;
				break;
			//{1,0,1};210magenta;//{1,0,.75}; 220 reddish magenta//{1,0,.5}; 230 cinnabar//{1,0,.25}; 240 reddish cinnabar
			case 21: case 22: case 23: case 24:
				curCol.R=1; curCol.G=0; curCol.B=1-(up2digts-21)*inc; 
				break;
			default:
				break;
		}//switch((int)i/10) END

		switch(i%10)
		{
			//12 TO 242;//13 TO 243;
			case 2:	case 3:
				curCol.R*=.65; curCol.G*=.65; curCol.B*=.65;
				break;
			//14 TO 244;//15 TO 245;
			case 4:	case 5:
				curCol.R*=.5; curCol.G*=.5; curCol.B*=.5;
				break;
			//16 TO 246;//17 TO 247;
			case 6:	case 7:
				curCol.R*=.3; curCol.G*=.3; curCol.B*=.3;
				break;
			//18 TO 248;//19 TO 249;
			case 8: case 9:
				curCol.R*=.15; curCol.G*=.15; curCol.B*=.15;
				break;
			default:
			//case 0://10 TO 240;//case 1://11 TO 241;
				break;
		}//switch (i%10) END

		//get maximum value among the R,G,B which got decayed with (*.65, *.5, *.3, *.15) in the last switch
		max=__max(__max(curCol.R, curCol.G),curCol.B);
		
		switch(i%10)
		{
			//11 TO 241;//13 TO 243;//15 TO 245;//17 TO 247;//19 TO 249; // Care odd cases
			case 1:	case 3:	case 5:	case 7:	case 9:
				curCol.R=curCol.R/2+max/2; curCol.G=curCol.G/2+max/2; curCol.B=curCol.B/2+max/2;
				break;
			default:
			//case 0://10 TO 240;//case 2://12 TO 242;//case 4://14 TO 244;//case 6://16 TO 246;//case 8://18 TO 248;
				break;
		}//switch (i%10) END
	}//i<250 END
	else if(i>=250)
	{
		curCol.R=.33; curCol.G=.33; curCol.B=.33;
		inc=.134;
		curCol.R=curCol.R+(i-250)*inc; curCol.G=curCol.G+(i-250)*inc; curCol.B=curCol.B+(i-250)*inc;
	}
	//printf("dxfColor%d: rgb<%.4f, %.4f, %.4f>\n", i, curCol.R, curCol.G, curCol.B);
	return (curCol);
}

